EDIT - bug #6546

Adding identifier does not always work
03/30/2017 11:47 AM - Andreas Mller

Status: In Progress Start date:

Priority: Highest Due date:

Assignee: Andreas Muller % Done: 0%
Category: cdmlib Estimated time: 0:00 hour
Target version: Reviewed Next Major Release

Severity: normal Found in Version: Release 4.5
Description

Probably this is related to the size() problem in PersistentLists (see #5211): If a PersistentList is detached (not bound to a session) it
adds new objects NOT to the underlying list but to an operationQueue. The operation queue is handled during reattache.

(from PersistentList line 312ff)

@Override

@SuppressWarnings ("unchecked")

public void add(int index, Object value) {

if ( index < 0 ) {

throw new ArrayIndexOutOfBoundsException( "negative index" );
}
if ( !isInitialized() || isConnectedToSession() ) {

// NOTE : we don't care about the inverse part here because
// even if the collection is inverse, this side is driving the
// writing of the indexes. And because this is a positioned-add
// we need to load the underlying elements to know how that
// affects overall re-ordering
write();
list.add( index, value );
}
else {
queueOperation( new Add( index, value ) );

The objects in the operationQueue are NOT considered when calling PersistentList.size().
Therefore calls to size like in IdentifiableEntity.addldentifier() create unexpected results.

@Override
public void addIdentifier (Identifier identifier) {
addIdentifier (getIdentifiers().size(), identifier);

The problem only exists if add() is called with an index, like add(int, obj). The default add(obj) handles the list as expected:

@Override
public boolean add(Object object) {
if ( !isOperationQueueEnabled() ) {
write();
return list.add( object );
}
else {
queueOperation( new SimpleAdd( object ) );
return true;

}

Related issues:
Related to EDIT - bug #5211: Error when creating new taxon /problem with sort... In Progress
https://dev.e-taxonomy.eu/redmine/issues/5211

Revision 26¢35e3a - 04/04/2017 10:50 PM - Andreas Miiller

ref #6546 avoid add() with index if not necessary

History

#1 - 03/30/2017 11:48 AM - Andreas Miiller

- Related to bug #5211: Error when creating new taxon /problem with sortindex in taxon tree added

#2 - 03/30/2017 04:57 PM - Andreas Miiller
- Description updated

- Status changed from New to In Progress

#3 - 09/25/2017 03:50 PM - Andreas Miiller

- Target version changed from Release 4.7 to Release 4.11

#4 - 11/08/2017 11:27 AM - Andreas Miiller

- Target version changed from Release 4.11 to Release 4.12

#5 - 12/05/2017 02:08 PM - Andreas Miuller

- Target version changed from Release 4.12 to Release 4.13

#6 - 01/31/2018 12:49 PM - Andreas Miuller

- Target version changed from Release 4.13 to Release 4.14

#7 - 02/15/2018 03:38 PM - Andreas Miuller

- Target version changed from Release 4.14 to Release 5.0

#8 - 05/14/2018 11:36 PM - Andreas Miuller

- Target version changed from Release 5.0 to Release 5.1

#9 - 06/27/2018 02:31 PM - Andreas Miller

- Target version changed from Release 5.1 to Release 5.2

#10 - 08/17/2018 04:04 PM - Andreas Miiller

- Target version changed from Release 5.2 to Release 5.3

#11 - 09/06/2018 10:05 AM - Andreas Miiller

- Target version changed from Release 5.3 to Release 5.4

#12 - 10/23/2018 12:46 PM - Andreas Miiller

- Target version changed from Release 5.4 to Release 5.5

#13 - 02/14/2019 10:38 PM - Andreas Miiller

- Target version changed from Release 5.5 to Release 5.6

#14 - 02/19/2019 05:04 PM - Andreas Miiller

- Target version changed from Release 5.6 to Reviewed Next Major Release
